%% Denoisy con wavelets (Imagenes)
% Leonardo Yamasaki
% Aplicaciones de la Transformada Wavelet
% Prof: Dr. Vicente Candela
%%
%Cargar imagenes
%
clear all;
clc;
close all;
load 'datos';
% lena   = imagen de lena sin ruido
% satel  = imagen de satelite
% simp   = seal discontinua sin ruido
% y      = seal continua



%% Lena
fig=1;
n=256;
I=lena;
sigma = 0.12 * (max(I(:))-min(I(:)));
In = I + sigma*randn(n); %Agrega ruido

level=2;
name='2D D2';

Iw=wavelet(name,level,I);

%treshold
T=sigma*1;
IwT= Iw .* (abs(Iw)>T);

Iwav = wavelet(name,-1*level,IwT);

%figure(1);
%subplot(1,3,1);
%imshow(I/256);
%subplot(1,3,2);
%figure(2);
%imshow(In/256);
%subplot(1,3,3);
%figure(3);
%imshow(Iwav/256);
%figure(4);
%imshow(IwT/256);


% wiener denoising
fI  = fft2(I);
fIn = fft2(In);
pf = abs(fI).^2;
% fourier transform of the wiener filter
hwf = pf./(pf+ n^2*sigma^2);   
%hw = fftshift( ifft2(hwf) );  
Iwien = real( ifft2(fIn .* hwf) );

% peak sig noisy ratio
sel = 1:n;
pwiener = psnr(I(sel,sel),Iwien(sel,sel));
pwav = psnr(I(sel,sel),Iwav(sel,sel));

figure(fig);fig=fig+1;
subplot(2,2,1);
imshow(I/256); axis image; axis off; title('Original');
subplot(2,2,2);
imshow(In/256); axis image; axis off; title('Con ruido');
subplot(2,2,3);
imshow(Iwav/256); axis image; axis off; title(sprintf('Wavelet %s PSNR:%.2f',name,pwav));
subplot(2,2,4);
imshow(Iwien/256); axis image; axis off; title(sprintf('Wiener fourier PSNR:%.2f',pwiener));

% Show details lena
figure(fig);fig=fig+1;
subplot(2,2,1);
imshow(imcrop(I/256,[120 110 70 70]));
title('Original')
subplot(2,2,2);
imshow(imcrop(In/256,[120 110 70 70]));
title('Con ruido');
subplot(2,2,3);
imshow(imcrop(Iwav/256,[120 110 70 70]));
title(sprintf('Wavelet %s PSNR:%.2f',name,pwav));
subplot(2,2,4);
imshow(imcrop(Iwien/256,[120 110 70 70]));
title(sprintf('Wiener fourier PSNR:%.2f',pwiener));


%% Satelite

n=256;
I=satel;
sigma = 0.12 * (max(I(:))-min(I(:)));
In = I + sigma*randn(n); %Agrega ruido

level=2;
name='2D Haar';

Iw=wavelet(name,level,I);

%treshold
T=sigma*1;
IwT= Iw .* (abs(Iw)>T);

Iwav = wavelet(name,-1*level,IwT);

%figure(1);
%subplot(1,3,1);
%imshow(I/256);
%subplot(1,3,2);
%figure(2);
%imshow(In/256);
%subplot(1,3,3);
%figure(3);
%imshow(Iwin/256);
%figure(4);
%imshow(IwT/256);

%%%%%%%%%%%
% wiener denoising
fI  = fft2(I);
fIn = fft2(In);
pf = abs(fI).^2;% spectral power
% fourier wiener filter
hwf = pf./(pf+ n^2*sigma^2);   
hw = fftshift( ifft2(hwf) );  
Iwien = real( ifft2(fIn .* hwf) );


% peak sig noisy ratio
pwiener = psnr(I(sel,sel),Iwien(sel,sel));
pwav = psnr(I(sel,sel),Iwav(sel,sel));

figure(fig);fig=fig+1;
subplot(2,2,1);
imshow(I/256); axis image; axis off; title('Original');
subplot(2,2,2);
imshow(In/256); axis image; axis off; title('Con ruido');
subplot(2,2,3);
imshow(Iwav/256); axis image; axis off; title(sprintf('Wavelet %s PSNR:%.2f',name,pwav));
subplot(2,2,4);
imshow(Iwien/256); axis image; axis off; title(sprintf('Wiener fourier PSNR:%.2f',pwiener));

% Show details satelite
figure(fig);fig=fig+1;
subplot(2,2,1);
imshow(imcrop(I/256,[120 110 70 70]));
title('Original')
subplot(2,2,2);
imshow(imcrop(In/256,[120 110 70 70]));
title('Con ruido');
subplot(2,2,3);
imshow(imcrop(Iwav/256,[120 110 70 70]));
title(sprintf('Wavelet %s PSNR:%.2f',name,pwav));
subplot(2,2,4);
imshow(imcrop(Iwien/256,[120 110 70 70]));
title(sprintf('Wiener fourier PSNR:%.2f',pwiener));
