%% Denoisy con wavelets (Seales)
% 2008, Copyright, Leonardo Yamasaki
% Aplicaciones de la Transformada Wavelet
% Prof: Dr. Vicente Candela
%%
%Cargar imagenes
%
clear all;
clc;
close all;
load 'datos';
% lena   = imagen de lena sin ruido
% satel  = imagen de satelite
% simp   = seal discontinua sin ruido
% y      = seal continua

%% simp seal con discontinuidades

%sigma seal ruido
n=numel(simp);
f=simp; %seal original
sigma = 0.08 * (max(f)-min(f)); 
fn = f +  sigma * randn(n,1)'; % Seal ruido

level=2;   %nivel
name='Haar'; %Que wavelet uso

fw = wavelet(name,level,fn);

Tlist = linspace( 0.2, 6, 16 )*sigma;
err = [];
figure(1);
for i = 1:length(Tlist)
    T = Tlist(i);
    % haz thresholding
    fwT = fw .* (abs(fw)>T);
    fwav = wavelet(name,-1*level,fwT); % inversa
    err = [ err, psnr(f,fwav) ];
    %plot sin ruidos
    if mod(i,4)==0 && i/4<=4
        subplot(5,1,i/4);
        plot(fwav);
        axis tight;
        title(sprintf('Nivel de treshold %.4f',T));
    end
end

% error
subplot(5,1,5);
plot(Tlist/sigma, err, '.-');
title('Error');
xlabel('T/sigma');
ylabel('Error');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% wavelet vs Wiener fourier

% linear (wiener)
ff  = fft(f);
ffn = fft(fn);
pf = abs(ff).^2;
% transformada fourier del filtro de wiener
hwf = pf./(pf+ n*sigma^2);   
% filtro en dominio espacial
%hw = fftshift( ifft(hwf) );
% haz el filtrado en fourier
fwien = real( ifft(ffn .* hwf) );

T = sigma*4;
fwT = fw .* (abs(fw)>T);
fwav = wavelet(name,-1*level,fwT); 

psnr_wav = psnr(f,fwav);
psnr_wien = psnr(f,fwien);

figure(2);
subplot(2,2,1);
plot(f); axis tight; title('Original');
subplot(2,2,2);
plot(fn); axis tight; title('Con ruido');
subplot(2,2,3);
plot(fwien); axis tight; title(sprintf('Wiener fourier psnr=%.2f',psnr_wien)); 
subplot(2,2,4);
plot(fwav); axis tight; title(sprintf('Wavelet %s psnr=%.2f',name,psnr_wav));


%% y seal continua 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%sigma seal ruido
n=numel(y);
f=y; %seal original
sigma = 0.08 * (max(f)-min(f)); 
fn = f +  sigma * randn(n,1)'; % Seal ruido

level=4;   %nivel
name='D4'; %Que wavelet uso

fw = wavelet(name,level,fn);

Tlist = linspace( 0.2, 6, 16 )*sigma;
figure(3);

err = [];
for i = 1:length(Tlist)
    T = Tlist(i);
    % haz thresholding
    fwT = fw .* (abs(fw)>T);
    fwav = wavelet(name,-1*level,fwT); % inversa
    err = [ err, psnr(f,fwav) ];
    if mod(i,4)==0 && i/4<=4
        subplot(5,1,i/4);
        plot(fwav);
        axis tight;
        title(sprintf('Nivel de treshold %.4f',T));
    end
end

% error
subplot(5,1,5);
plot(Tlist/sigma, err, '.-');
title('Error');
xlabel('T/sigma');
ylabel('Error');


%% continua
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% wavelet vs Wiener

% linear (wiener)
ff  = fft(f);
ffn = fft(fn);
pf = abs(ff).^2;
% transformada fourier del filtro de wiener
hwf = pf./(pf+ n*sigma^2);   
% filtro en dominio espacial
hw = fftshift( ifft(hwf) );                
% haz el filtrado en fourier
fwien = real( ifft(ffn .* hwf) );

T = sigma*4;
% thresholding
fwT = fw .* (abs(fw)>T);
% inverse
fwav = wavelet(name,-1*level,fwT); 

psnr_wav = psnr(f,fwav);
psnr_wien = psnr(f,fwien);

figure(4);
subplot(2,2,1);
plot(f); axis tight; title('Original');
subplot(2,2,2);
plot(fn); axis tight; title('Con ruido');
subplot(2,2,3);
plot(fwien); axis tight; title(sprintf('Wiener fourier psnr=%.2f',psnr_wien)); 
subplot(2,2,4);
plot(fwav); axis tight; title(sprintf('Wavelet %s psnr=%.2f',name,psnr_wav));

